unit NbHilit;

{  Electro-Concept Mauricie, 1999 }
{ Implements TNumberHighlighter object, used for dynamic highlighting of numbers
  in a TPlusMemo }

interface

uses
  Windows, Messages, SysUtils, Graphics, Controls, Forms, Dialogs,
  Plusmemo, ExtHilit;

type
  TNumberHighlighter = class(TCustomExtHighlighter)
  protected
    procedure ApplyKeywordsList(Start, Stop: TPlusNavigator; BaseIndex: Integer);  override;
    function OkContext(const dyn: DynInfoRec): Boolean;

  public
    property Delimiters;

  published
    { promotes from TCustomExtHighlighter }
    property AltFont;
    property Background;
    property ContextNum;
    property Foreground;
    property Separators;
    property Style;
    property Scope;
    property Priority;
    property OnQueryHilit;
  end;

procedure Register;

implementation

uses Classes;

const DigitSet  = ['0'..'9'];
      HDigitSet = DigitSet + [ 'a'..'f', 'A'..'F'];

procedure Register;
begin
  RegisterComponents('ECM', [TNumberHighlighter]);
end;


{ TNumberHighlighter }
type TPPlusMemo = class(TPlusMemo);

function getlevel(const dyn: DynInfoRec): SmallInt;
begin
  if dyn.DynStyle and $c0 <>$c0 then Result:= -1
                                else Result:= dyn.Level
end;

procedure TNumberHighlighter.ApplyKeywordsList(Start, Stop: TPlusNavigator; BaseIndex: Integer);
  type keyinfo = record start, stop: PlusCardinal end;
  var
    foundcount: Integer;
    foundsome : Boolean;
    nbfound   : array[0..15] of keyinfo;
    smemo     : TPPlusMemo;

  procedure applynbfound;
    var needed: PlusCardinal;
        drec: DynInfoRec;  k, currentlevel: SmallInt;
    begin
    foundsome:= True;
    fNav1.fPMemo:= smemo;
    fNav2.fPMemo:= smemo;
    with fNav1 do
      begin
      fPar:= Start.Par; fPos:= fPar^.StartOffset;
      fDynNb:= 0; fOffset:= 0;
      fParLine:= High(fParLine);
      fParNb:= Start.fParNb;
      end;

    with fNav1.fPar^ do
      begin
      needed:= DynCount+foundcount*2;
      if needed>DynBufLen then
        begin
        {$IFNDEF WIN32} Plussup. {$ENDIF} ReAllocMem(DynBuffer, {$IFNDEF WIN32} DynBufLen*DCodeLen, {$ENDIF} needed*DCodeLen);
        DynBufLen:= needed
        end
      end;

    for k:= 0 to foundcount-1 do
         begin
         fNav1.Pos:= fNav1.fPar^.StartOffset+nbfound[k].start;
         fNav1.RightOfDyn;
         currentlevel:= getlevel(fNav1.pDynAttr^);
         if currentlevel<15 then
           begin
           fNav2.Assign(fNav1);
           fNav2.Pos:= fNav2.Pos+ (nbfound[k].stop-nbfound[k].start);
           with drec do
             begin
             KeyIndex:= fNav1.DynAttr.KeyIndex;
             DynStyle:= Byte(Style) or $c0;
             if AltFont then DynStyle:= DynStyle or (1 shl Ord(fsAltFont));
             Backgnd:= Background;
             Foregnd:= Foreground;
             Context:= ContextNum;
             Cursor:= crDefault;
             StartKLen:= fNav2.Pos-fNav1.Pos;
             StopKLen:= StartKLen;
             Level:= CurrentLevel+1;
             KeyIndex[Level]:= BaseIndex;
             end;

           smemo.SetDynStyleP(fNav1, fNav2, drec, True, False);
           end
         end;
    fNav1.fPMemo:= nil;
    fNav2.fPMemo:= nil;
    foundcount:= 0;
    end;  { local proc. applynbfound }

  var
    runoff, stopoff,
    startword, rundynnb,
    runlim             : PlusCardinal;
    ok        : Boolean;
    i         : Integer;
    rundynp   : pDynInfoRec;
    t         : PChar;
    isnb      : Boolean;

begin
  runoff:= Start.ParOffset;
  if runoff>0 then Dec(runoff);
  rundynnb:= Start.DynNb;
  rundynp:= Start.pDynAttr;
  stopoff:= Stop.ParOffset;
  if stopoff<Start.fPar^.Length then Inc(stopoff);
  t:= Start.fPar^.Text;
  foundcount:= 0;
  foundsome:= False;
  smemo:= TPPlusMemo(Start.fPMemo);

  { reach the start of word }
  while (runoff>0) and (not (t[runoff-1] in Delimiters)) do Dec(runoff);

  if rundynnb>0 then
    while runoff<rundynp^.DynOffset do
      begin
        Dec(rundynnb);
        if rundynnb>0 then rundynp:= @Start.fPar^.DynBuffer[rundynnb-1]
                      else
                        begin
                          rundynp:= Start.fPar^.StartDynAttrib;
                          Break
                        end
      end;

  if rundynnb<Start.fPar^.DynCount then runlim:= Start.fPar^.DynBuffer[rundynnb].DynOffset
                                   else runlim:= High(runlim);
  ok:= OkContext(rundynp^);

  repeat
    { reach start of word }
    while (runoff<stopoff) and (t[runoff] in Delimiters) do Inc(runoff);

    repeat
      while (runoff>=runlim) and (runoff<=stopoff) do
        begin
          rundynp:= @Start.fPar^.DynBuffer[rundynnb];
          Inc(rundynnb);
          if rundynnb<Start.fPar^.DynCount then runlim:= Start.fPar^.DynBuffer[rundynnb].DynOffset
                                           else runlim:= High(runlim);
          ok:= OkContext(rundynp^)
        end;


      if not ok then
        begin
          while (runoff<stopoff) and (not ok) do
            begin
              runoff:= runlim;
              if runoff<High(runlim) then
                begin
                  rundynp:= @Start.fPar^.DynBuffer[rundynnb];
                  Inc(rundynnb);
                  if rundynnb<Start.fPar^.DynCount then runlim:= Start.fPar^.DynBuffer[rundynnb].DynOffset
                                                   else runlim:= High(runlim);
                  ok:= OkContext(rundynp^)
                end
            end;

          { reach start of word }
          while (runoff<stopoff) and (not (t[runoff] in Delimiters)) do Inc(runoff);
          while (runoff<stopoff) and (t[runoff] in Delimiters) do Inc(runoff)
        end
    until (ok and (runoff<runlim)) or (runoff>=stopoff);

    if runoff<stopoff then
      begin
      startword:= runoff;
      { reach end of word }
      Inc(runoff);
      while (not (t[runoff] in Delimiters)) and (t[runoff]<>#0) do Inc(runoff);

      if (runoff>startword) and (runoff<=runlim) then
        begin
        isnb:= False;
        if t[startword]='$' then
            begin
            isnb:= True;
            for i:= startword+1 to runoff-1 do
              if not (t[i] in HDigitSet) then
                begin
                  isnb:= False;
                  Break
                end
            end
        else
          if t[startword] in DigitSet then
            begin
            isnb:= True;
            for i:= startword+1 to runoff-1 do
              if not (t[i] in DigitSet) then
                begin
                  isnb:= False;
                  Break
                end
            end;

       if isnb then
         begin
           nbfound[foundcount].start:= startword;
           nbfound[foundcount].stop:= runoff;
           Inc(foundcount);
           if foundcount=16 then applynbfound
         end
       end
      end
  until runoff>=stopoff;

  if foundcount>0 then applynbfound;
  if foundsome then InvalidateNavs(smemo.fNavigators, Start.fPar^.StartOffset, Start.ParNumber)

end;

function TNumberHighlighter.OkContext(const dyn: DynInfoRec): Boolean;
var curscope: SmallInt;
begin
  if dyn.DynStyle and $80 = 0 then curscope:= 0
  else
    if dyn.DynStyle and $c0 = $c0 then curscope:= dyn.Context
                                  else curscope:= Low(curscope);
  Result:= Scope=curscope;
  if Assigned(OnQueryHilit) then OnQueryHilit(Self, curscope, Result)
end;

end.
